SJ = LibStub("AceAddon-3.0"):NewAddon("SJ", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0")

local PREFIX = "[SecondJob]"
local VERSION="r26"
local characterInfo = nil
local debug=false
local allowUpdates=true


SJ.defaults = {
	char = {
		icon = {
			hide = false,
		},
		framePosition = {
			x = 0,
			y = 0,
			anchor = "CENTER"
		},
		character = {
		
			--[["Crianthia|Trollbane|ALLIANCE"] = {
				checkedQuests = {},
				allQuests = {},
				timestamp = nil,
			}]]
		
		},
		tracked={
			Sha=true,
			galleon=false,
			ElderCharms=true,
			Blingtron=true,
			Klaxxi=false,
			GoldenLotus=false,
			ShadoPan=true,
			AugustCelestials=false,
			ShieldWall=true

		}
	},
}
SJ.LDB = LibStub("LibDataBroker-1.1"):NewDataObject("SJList", {
	type = "data source",
	text = "SecondJob",
	--icon = "Interface\\RAIDFRAME\\ReadyCheck-Waiting.blp",
	icon = "Interface\\CURSOR\\QuestRepeatable.blp",
	OnTooltipShow = function(tt)
		tt:AddLine("SecondJob")
		tt:AddLine("|cffffff00" .. "Left Click to open options")
	end,
	OnClick = function(self, button) SJ:showOptions() end,
})
SJ.icon = LibStub("LibDBIcon-1.0")
function SJ:RecreateTrackingFrame()

	for k,v in pairs(self.sjquestFrame.quests) do 
		self.sjquestFrame.quests[k].headerText:SetText("")
		self.sjquestFrame.quests[k]=nil 
	end
	local offset = 0
	offset = offset + 18
	for i=1, table.getn(order), 1 do	
		group=questList[order[i]]
		name=order[i]
		if self.db.char.tracked[name] then
			self:CreateQuestInSJquestFrame(group["name"],name, offset)
			offset = offset + 16
		end
	end
end

function SJ:CreateTrackingFrame()
    self.sjquestFrame = CreateFrame("Frame","sjquestFrame",UIParent)
	self.sjquestFrame:SetMovable(true)
	self.sjquestFrame:EnableMouse(true)
	self.sjquestFrame:SetClampedToScreen(true)
	self.sjquestFrame:RegisterForDrag("LeftButton")
	self.sjquestFrame:SetScript("OnDragStart", function(frame)
			frame:StartMoving() 
		end)
	self.sjquestFrame:SetScript("OnDragStop", function(frame)
			frame:StopMovingOrSizing()
			self.db.char.framePosition.anchor, _, _, self.db.char.framePosition.x, self.db.char.framePosition.y = frame:GetPoint()
		end)
	self.sjquestFrame:SetBackdropColor(0,0,0,1);
	self.sjquestFrame:SetHeight(200)
	self.sjquestFrame:SetWidth(200)
	self.sjquestFrame:SetAlpha(1.0)
	
	-- Create empty array to store quests
	self.sjquestFrame.quests = {}
	
	-- Vertical offset to keep track of position of new text lines
	local offset = 0
	
	-- Create the title text
	local title = self.sjquestFrame:CreateFontString("TitleText", nil, "GameFontNormalLarge")
	title:SetText("|cffFFB90FSecondJob|r")
	title:SetPoint("TOPLEFT", self.sjquestFrame, "TOPLEFT", -4, -offset)
	title:Show()
	
	-- Adjust offset for beginning of list
	offset = offset + 18
	for i=1, table.getn(order), 1 do	
		group=questList[order[i]]
		name=order[i]
		if self.db.char.tracked[name] then
			self:CreateQuestInSJquestFrame(group["name"],name, offset)
		
		offset = offset + 16
		end
	end

	self.sjquestFrame:SetHeight(32)
	self.sjquestFrame:SetPoint(self.db.char.framePosition.anchor, nil, self.db.char.framePosition.anchor, self.db.char.framePosition.x, self.db.char.framePosition.y-16)
	self.sjquestFrame:SetPoint("TOPLEFT", 5, 15)
end

function SJ:CreateQuestInSJquestFrame(questTitle, questId, offset)
	self.sjquestFrame.quests[questId] = {}
	local mytext=SJ:isGroupCompletedByIndex(questId)
	self.sjquestFrame.quests[questId].headerText = self.sjquestFrame:CreateFontString("QuestHeader"..questId, nil, "ChatFontNormal")
	self.sjquestFrame.quests[questId].headerText:SetText(questTitle.." "..mytext)
	self.sjquestFrame.quests[questId].headerText:SetPoint("TOPLEFT", self.sjquestFrame, "TOPLEFT", 16, -offset)
	self.sjquestFrame.quests[questId].headerText:Show()
	
end

function SJ:toggleFrame()
	if not self.sjquestFrame:IsShown() then
		self.sjquestFrame:Show()
		allowUpdates=true
	else
		self.sjquestFrame:Hide()
		allowUpdates=false
	end
end

function SJ:toggleDebug()
	if debug then
		debug=false
		DEFAULT_CHAT_FRAME:AddMessage("Debug disabled")
	else
		debug=true
		DEFAULT_CHAT_FRAME:AddMessage("Debug enabled!")
	end
end

function SJ:OnInitialize()

	RegisterAddonMessagePrefix(PREFIX)
	SJ:RegisterChatCommand("sj_toggle", "toggleFrame")
	SJ:RegisterChatCommand("sj_toggle_debug", "toggleDebug")
	SJ:RegisterChatCommand("sj_refresh", "Refresh")
	SJ:RegisterChatCommand("sj_version", "version")
	SJ:RegisterChatCommand("sj_test", "updateGroups")
	SJ:RegisterChatCommand("sj_test2", "test2")
	SJ:RegisterChatCommand("sj_options", "showOptions")
	self.db = LibStub("AceDB-3.0"):New("SecondJobDB", self.defaults,global)
	self.icon:Register("SJList", self.LDB, self.db.char.icon)
	self:CreateTrackingFrame()
	SJ:loadOptionsFrame()
end

function SJ:OnEnable()
	self:Print("Addon SecondJob enabled.  Use '/sj_toggle' to show/hide, /sj_options to configure")
	characterInfo = UnitName("player").."|"..GetRealmName().."|"..string.upper(UnitFactionGroup("player"))

	if not self.db.char.character[characterInfo] then
		self.db.char.character[characterInfo] = {}
	end
	self.maxEntries = (InterfaceOptionsFramePanelContainer:GetHeight() - 170) / 20

end

function SJ:version()
	self:Print("Version:"..VERSION)

end

function SJ:Test()
	local j=1
	--for i=1,GetNumTradeSkills() do
	for i=GetNumTradeSkills(), 1, -1 do
	--for i=1,100 do
		local cooldown = GetTradeSkillCooldown(i)
		local name = GetTradeSkillInfo(i)
		if name=="Sha Crystal" then
	
			print("sha crystal"..cooldown)
		end
		if name=="Scroll of Wisdom" then
	
			print("Scroll of Wisdom"..cooldown)
		end

	--	if cooldown then
        
	--	   print("Cooldown remaining for " .. name .. "("..i.."): " .. SecondsToTime(cooldown))
	--	print(name)
	--	end
		j=j+1
	end
	prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions()
	print("prof1: "..GetProfessionInfo(prof1))
	print("prof2: "..GetProfessionInfo(prof2))

	print (j.." total")
end


local frame, events = CreateFrame("Frame"), {};
function events:QUEST_FINISHED(...)
if debug then DEFAULT_CHAT_FRAME:AddMessage("Event QUEST_FINISHED Fired!") end
SJ:Refresh()
end
function events:QUEST_LOG_UPDATE(...)
if debug then DEFAULT_CHAT_FRAME:AddMessage("Event QUEST_LOG_UPDATE Fired") end
SJ:Refresh()
end
frame:SetScript("OnEvent", function(self, event, ...)
 events[event](self, ...); -- call one of the functions above
end);
for k, v in pairs(events) do
 frame:RegisterEvent(k); -- Register all events for which handlers have been defined
end

total=0

function SJ:Refresh()
	if debug then DEFAULT_CHAT_FRAME:AddMessage("Start refresh!") end
	SJ:updateGroups()
end

local function onUpdate(self,elapsed)
    total = total + elapsed
    if total >= 30 then
       if debug then DEFAULT_CHAT_FRAME:AddMessage("Start refresh!") end
		if allowUpdates then
			SJ:Refresh()
		end
		total=0
    end
end
local f = CreateFrame("frame")
f:SetScript("OnUpdate", onUpdate)

--[[Function isGroupCompleted(group)

Deprecated, but left here for reference. Not maintained. See isGroupCompletedByIndex(idx)

function SJ:isGroupCompleted(group)
	local completed="N"
	for questInd, quest in pairs(group) do
	
		if type(quest)=="table" then
			for id, q in pairs(quest) do -- only one needs completion
				--
				if type(q)=="table" then
					for id1, q1 in pairs(q) do
						if debug then DEFAULT_CHAT_FRAME:AddMessage("checkingq1 "..q1) end
						if  IsQuestFlaggedCompleted(q1) then
							--completed="Y"
							break
						end
						completed="N"
					end
				else
					if debug then DEFAULT_CHAT_FRAME:AddMessage("checkingq "..q) end
					if  IsQuestFlaggedCompleted(q) then
						completed="Y"
						break
					end
				end
			end
		else --solo items, like blingtron
			if debug then DEFAULT_CHAT_FRAME:AddMessage("checkingquest "..quest) end
			if  IsQuestFlaggedCompleted(quest) then
				completed="Y"
			end
		end
		
		
	end
	if debug then DEFAULT_CHAT_FRAME:AddMessage(" status: "..completed) end
	return completed	
end
--]]
--[[
function SJ:isGroupCompletedByIndex(index)
	local completed="|cFFFF0000N|r"
	local group=questList[index]["quests"]
	for questInd, quest in pairs(group) do
		--if completed=="|cFF00FF00Y|r" then break end
		if type(quest)=="table" then --nested OR group
			for id, q in pairs(quest) do 
				--
				if type(q)=="table" then
					
					for id1, q1 in pairs(q) do
						if debug then DEFAULT_CHAT_FRAME:AddMessage("checkingq1 "..q1) end
						if  IsQuestFlaggedCompleted(q1) then
							completed="|cFF00FF00Y|r"
							break
						end
						--completed="N"
					end
				else 
					if debug then DEFAULT_CHAT_FRAME:AddMessage("checkingq "..q) end
					if  IsQuestFlaggedCompleted(q) then
						completed="|cFF00FF00Y|r"
						--break
					else
						completed="|cFFFF0000N|r"
						break
					end
				end
			end
		else --solo items, like blingtron
			if debug then DEFAULT_CHAT_FRAME:AddMessage("checkingquest "..quest) end
			if  IsQuestFlaggedCompleted(quest) then
				completed="|cFF00FF00Y|r"
			else
				if quest==32016 then
					name, currentAmount, texture, earnedThisWeek, weeklyMax, totalMax, isDiscovered = GetCurrencyInfo(738)
					if currentAmount>=90 then
						completed = "|cFFFF0000N |cFF00FF00("..currentAmount..")|r"
					else
						completed = "|cFFFF0000N ("..currentAmount..")|r"
					end
				end
			end
		end
		
		
	end
	--]]
function SJ:isGroupCompletedByIndex(index)
	local completed="N"
	local group=questList[index]["quests"]
	for questInd, quest in pairs(group) do
		if type(quest)~="table" then 
			if debug then DEFAULT_CHAT_FRAME:AddMessage("checkingquest "..quest) end
			if  IsQuestFlaggedCompleted(quest) then
				completed="Y"
			else
				completed="N"
			end
		else 
			for id, q in pairs(quest) do 
				completed="N"
				if type(q)~="table" then	
					if debug then DEFAULT_CHAT_FRAME:AddMessage("checkingq "..q) end
					if  IsQuestFlaggedCompleted(q) then
						completed="Y"
					end
				else 
			
					for id1, q1 in pairs(q) do
						if debug then DEFAULT_CHAT_FRAME:AddMessage("checkingq1 "..q1) end
						if  IsQuestFlaggedCompleted(q1) then
							completed="Y"
							break
						end
					end
				
				end
				if completed=="N" then break end
			end		
			if completed=="Y" then break end
		end
		
	end
	--completed="|cFFFF0000N|r"
	--completed="|cFF00FF00Y|r"
	
	if completed=="N" then
		if index=="ElderCharms" then
			name, currentAmount, texture, earnedThisWeek, weeklyMax, totalMax, isDiscovered = GetCurrencyInfo(738)
			if currentAmount>=90 then
				completed = "|cFFFF0000N |cFF00FF00("..currentAmount..")|r"
				completed="N"
			else
				completed = "|cFFFF0000N ("..currentAmount..")|r"
			end
		else
			completed="|cFFFF0000N|r"
		end
    else
		completed="|cFF00FF00Y|r"
	end
	if debug then DEFAULT_CHAT_FRAME:AddMessage(" status: "..completed) end
	return completed	
end

function SJ:updateGroups()
	local name=""
	for i=1, table.getn(order), 1 do	
		group=questList[order[i]]
		name=order[i]
		local c="N"
		if self.db.char.tracked[name] then	
			c=SJ:isGroupCompletedByIndex(name)
			if debug then DEFAULT_CHAT_FRAME:AddMessage(name .. "|" .. group["name"].."|".. c) end
			self.sjquestFrame.quests[name].headerText:SetText(group["name"].." "..c)
		end
	end
end

--[[functions below are OnClick handlers for checkbuttons in the options panel.
If a new faction is added, a function needs to be added. Also needs to be added to
the SJ: namespace in the .xml
--]]
--[[function SJ:cbSha_OnClick()
	if cbSha:GetChecked() then
		self.db.char.tracked.Sha=true	
	else
		self.db.char.tracked.Sha=false
	end
end

function SJ:cbGalleon_OnClick()
	if cbGalleon:GetChecked() then
		self.db.char.tracked.Galleon=true	
	else
		self.db.char.tracked.Galleon=false
	end
end

function SJ:cbElder_OnClick()
	if cbElder:GetChecked() then
		self.db.char.tracked.ElderCharms=true	
	else
		self.db.char.tracked.ElderCharms=false
	end
end

function SJ:cbBling_OnClick()
	if cbBling:GetChecked() then
		self.db.char.tracked.Blingtron=true	
	else
		self.db.char.tracked.Blingtron=false
	end
end

function SJ:cbKlaxxi_OnClick()
	if cbKlaxxi:GetChecked() then
		self.db.char.tracked.Klaxxi=true	
	else
		self.db.char.tracked.Klaxxi=false
	end
end

function SJ:cbGoldenLotus_OnClick()
	if cbGoldenLotus:GetChecked() then
		self.db.char.tracked.GoldenLotus=true	
	else
		self.db.char.tracked.GoldenLotus=false
	end
end

function SJ:cbShadoPan_OnClick()
	if cbShadoPan:GetChecked() then
		self.db.char.tracked.ShadoPan=true	
	else
		self.db.char.tracked.ShadoPan=false
	end
end

function SJ:cbAugCele_OnClick()
	if cbAugCele:GetChecked() then
		self.db.char.tracked.AugustCelestials=true	
	else
		self.db.char.tracked.AugustCelestials=false
	end
end
function SJ:cbShieldWall_OnClick()
	if cbShieldWall:GetChecked() then
		self.db.char.tracked.ShieldWall=true	
	else
		self.db.char.tracked.ShieldWall=false
	end
end
--]]

--hide the options panel when it's loaded.
function frmOptions_OnLoad()
	frmOptions:Hide()
end

--show the options panel
function SJ:showOptions()

	allowUpdates=false
	frmOptions:Show()

end

--another test function
function SJ:test2()
	if self.db.char.tracked.Sha then
		DEFAULT_CHAT_FRAME:AddMessage("Sha: Y")
	else
		DEFAULT_CHAT_FRAME:AddMessage("Sha: N")
	end
	if self.db.char.tracked["Sha"] then
		DEFAULT_CHAT_FRAME:AddMessage("Sha: Y")
	else
		DEFAULT_CHAT_FRAME:AddMessage("Sha: N")
	end
end

--load the variables into the checkboxes.
function SJ:loadOptionsFrame()
	if self.db.char.tracked.Sha then
		cbSha:SetChecked(true)
	end
	if self.db.char.tracked.Galleon then
		cbGalleon:SetChecked(true)
	end
	if self.db.char.tracked.ElderCharms then
		cbElder:SetChecked(true)
	end
	if self.db.char.tracked.Blingtron then
		cbBling:SetChecked(true)
	end
	if self.db.char.tracked.Klaxxi then
		cbKlaxxi:SetChecked(true)
	end	
	if self.db.char.tracked.GoldenLotus then
		cbGoldenLotus:SetChecked(true)
	end
	if self.db.char.tracked.ShadoPan then
		cbShadoPan:SetChecked(true)
	end
	if self.db.char.tracked.AugustCelestials then
		cbAugCele:SetChecked(true)
	end
	if self.db.char.tracked.ShieldWall then
		cbShieldWall:SetChecked(true)
	end
end

--[[the OK button in the options panel. When clicked, change the frame.
--]]
function SJ:Button1_OnClick()
	if cbSha:GetChecked() then
		self.db.char.tracked.Sha=true	
	else
		self.db.char.tracked.Sha=false
	end
	if cbGalleon:GetChecked() then
		self.db.char.tracked.Galleon=true	
	else
		self.db.char.tracked.Galleon=false
	end
	
	if cbElder:GetChecked() then
		self.db.char.tracked.ElderCharms=true	
	else
		self.db.char.tracked.ElderCharms=false
	end
	
	if cbBling:GetChecked() then
		self.db.char.tracked.Blingtron=true	
	else
		self.db.char.tracked.Blingtron=false
	end
	
	if cbKlaxxi:GetChecked() then
		self.db.char.tracked.Klaxxi=true	
	else
		self.db.char.tracked.Klaxxi=false
	end
	
	if cbGoldenLotus:GetChecked() then
		self.db.char.tracked.GoldenLotus=true	
	else
		self.db.char.tracked.GoldenLotus=false
	end
	
	if cbShadoPan:GetChecked() then
		self.db.char.tracked.ShadoPan=true	
	else
		self.db.char.tracked.ShadoPan=false
	end
	
	if cbAugCele:GetChecked() then
		self.db.char.tracked.AugustCelestials=true	
	else
		self.db.char.tracked.AugustCelestials=false
	end
	
	if cbShieldWall:GetChecked() then
		self.db.char.tracked.ShieldWall=true	
	else
		self.db.char.tracked.ShieldWall=false
	end

	frmOptions:Hide()
	SJ:RecreateTrackingFrame()
	allowUpdates=true
end
